/*******************************************************************
  uLan Utilities Library - C library of basic reusable constructions

  ul_logreg.h	- registration of logging domains

  (C) Copyright 2006 by Pavel Pisa - Originator

  The uLan utilities library can be used, copied and modified under
  next licenses
    - GPL - GNU General Public License
    - LGPL - GNU Lesser General Public License
    - MPL - Mozilla Public License
    - and other licenses added by project originators
  Code can be modified and re-distributed under any combination
  of the above listed licenses. If contributor does not agree with
  some of the licenses, he/she can delete appropriate line.
  Warning, if you delete all lines, you are not allowed to
  distribute source code and/or binaries utilizing code.
  
  See files COPYING and README for details.

 *******************************************************************/

#include <ul_logbase.h>

#ifndef _UL_LOGREG_H
#define _UL_LOGREG_H

#ifdef __cplusplus
extern "C" {
#endif

int ul_log_domain_setlevel(const char *name, int setlevel);
int ul_log_domain_getlevel(const char *name);

int ul_logreg_domain(ul_log_domain_t *domain);
int ul_logreg_domains_static(ul_log_domain_t *const *domains, int count);
int ul_log_domain_arg2levels(const char *arg);

#ifdef __cplusplus
} /* extern "C"*/
#endif

#endif /*_UL_LOGREG_H*/
