#ifndef SOCKNODE_H
#define SOCKNODE_H

#include <ul_dbuff.h>
#include <vca_fdpoll.h>

struct vcaNet_t;

typedef struct FdNodeSrvSock_t 
{
    vcaFdNode_t fdnode;
    struct vcaNet_t *cannet; /* all client connection will be initialized with this NET */
} FdNodeSrvSock_t;

/**
 * FdNodeSrvSock_init - constructor
 * @sock if NULL function calls malloc() and return created and initialized object
 */
FdNodeSrvSock_t* FdNodeSrvSock_init(FdNodeSrvSock_t *sock);
/**
 * FdNodeSrvSock_destroy - destructor
 */
void FdNodeSrvSock_destroy(FdNodeSrvSock_t *sock);

typedef struct FdNodeCliSock_t 
{
    vcaFdNode_t fdnode;
    int packet_len;
    ul_dbuff_t msgdb;
    struct vcaNet_t *cannet;
    
    evc_rx_hub_t rough_canmsg_hub; // HUB for rough CAN messages

    ul_list_head_t rq_que;
} FdNodeCliSock_t;

/**
 * FdNodeCliSock_init - constructor
 * @sock if NULL function calls malloc(0 and return created and initialized object
 */
FdNodeCliSock_t* FdNodeCliSock_init(FdNodeCliSock_t *sock);
/**
 * FdNodeCliSock_destroy - destructor
 */
void FdNodeCliSock_destroy(FdNodeCliSock_t *sock);

#endif // SOCKNODE_H

