#include <string.h>

#ifndef __RTL__

#include <math.h>
#include <stdio.h>

#else /*__RTL__*/

#include <rtl.h>
#include <signal.h>
#include <pthread.h>
#define printf rtl_printf

#endif /*__RTL__*/

#include "ul_utmalloc.h"
#include "ul_evcbase.h"
#include "sui_event.h"
#include "sui_dinfo.h"
#include "sui_dievc.h"
#include "sui_dtrans.h"

int val1;
sui_dinfo_t *dinfo1w;
sui_dinfo_t *dinfo1;
evc_rx_hub_t hub1;

void hub1_hevent(evc_rx_hub_t *hub, sui_event_t *event)
{
  long val = 999;
  sui_dinfo_t *calling_dinfo = (sui_dinfo_t*)(event->u_u.message.ptr);
  printf("hub1_hevent called\n");
  sui_rd_long(calling_dinfo, 0, &val);
  printf("\tsui_rd_long(%p) returned %li\n", event->u_u.message.ptr, val);
}

int main(int argc, char *argv[])
{  
  long val;

  dinfo1 = sui_create_dinfo_int(&val1, 1, sizeof(val1));
  printf("dinfo %p created\n", dinfo1);
  evc_rx_hub_init(&hub1, (evc_rx_fnc_t*)&hub1_hevent, &hub1);

  sui_dinfo_connect_to_hub(dinfo1, &hub1, NULL);

  val=123;
  printf("sui_wr_long(%li) called\n", val);
  sui_wr_long(dinfo1, 0, &val);

  dinfo1w=dinfo1;
  sui_dinfo_add_weakptr(dinfo1, &dinfo1w);

  sui_dinfo_connect_to_hub(dinfo1, &hub1, NULL);
  sui_dinfo_connect_to_hub(dinfo1, &hub1, NULL);
  sui_dinfo_connect_to_hub(dinfo1, &hub1, NULL);

  val=2345;
  printf("sui_wr_long(%li) called\n", val);
  sui_wr_long(dinfo1, 0, &val);
  
  sui_dinfo_dec_refcnt(dinfo1);
  dinfo1=NULL;
  
  printf("dinfo1w %p\n",dinfo1w);
  
  return 0;
}

/*===========================================================*/
#ifdef __RTL__

pthread_t t1;

void * t1_routine(void *arg)
{
  main(0, NULL);

  while (1) {
    pthread_wait_np ();
  }
  return 0;
}


int init_module(void) {
        return pthread_create (&t1, NULL, t1_routine, 0);

}

void cleanup_module(void) {
        pthread_delete_np (t1);
}

#endif /*__RTL__*/
